﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using EventStore.ClientAPI;
using EventStore.ClientAPI.SystemData;

namespace ES_TestProject
{
    public class ESConnection
    {
        public IEventStoreConnection Connection { get; private set; }

        public ESConnection()
        {
            const string clusterNodes = "192.168.0.1:2123,192.168.0.2:2123,192.168.0.3:2123";
            const string userName = "admin";
            const string password = "changeit";

            var userCredentials = new UserCredentials(userName, password);
            var settings = ConnectionSettings.Create()
                .SetDefaultUserCredentials(userCredentials)
                .KeepReconnecting()
                .PerformOnAnyNode();
            var nodes = clusterNodes.Split(',').Select(p =>
            {
                var splitString = p.Split(':');
                var ipAddressString = splitString[0];
                var portNumberString = splitString[1];
                var portNumber = Convert.ToInt32(portNumberString);
                var cIpAddress = IPAddress.Parse(ipAddressString);
                return new IPEndPoint(cIpAddress, portNumber);
            }).ToArray();

            ClusterSettings clusterSettings = ClusterSettings.Create()
                .DiscoverClusterViaGossipSeeds()
                .SetGossipSeedEndPoints(nodes);


            Connection = EventStoreConnection.Create(settings, clusterSettings);
            var connectTask = Connection.ConnectAsync();
            connectTask.Wait();
        }
    }
}
