﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;

namespace ES_TestProject
{
    public static class SerializationExtensions
    {
        private static readonly JsonSerializerSettings Settings = new JsonSerializerSettings()
        {
            ContractResolver = new CustomContractResolver()
        };

        public static byte[] Serialize(dynamic o)
        {
            var dataString = JsonConvert.SerializeObject(o, Settings);
            return Encoding.UTF8.GetBytes(dataString);
        }

        public static dynamic Deserialize(byte[] bytes, Type type)
        {
            var dataString = Encoding.UTF8.GetString(bytes);
            return JsonConvert.DeserializeObject(dataString, type, Settings);
        }

        public static dynamic Deserialize(byte[] bytes, string typeString)
        {
            var type = Type.GetType(typeString);
            return Deserialize(bytes, type);
        }

    }

    public class CustomContractResolver : DefaultContractResolver
    {
        protected override JsonProperty CreateProperty(MemberInfo member, MemberSerialization memberSerialization)
        {
            var prop = base.CreateProperty(member, memberSerialization);

            if (!prop.Writable)
            {
                var property = member as PropertyInfo;
                if (property != null)
                {
                    var hasPrivateSetter = property.GetSetMethod(true) != null;
                    prop.Writable = hasPrivateSetter;
                }
            }

            return prop;
        }
    }
}
